#include <rf60Xsdk.h>
#include <rf60Xtypes.h>

#include <iostream>

using namespace SDK;
using namespace SCANNERS;
using namespace RF60X;

int main() {
  // Initialize sdk library
  sdk_init();

  // Print return rf60X sdk version
  std::cout << sdk_version() << std::endl;

  config_base_information_rf60x_t config_params_device;

  config_params_device.type = SCANNER_TYPE::RF60x;
  config_params_device.protocol = PROTOCOLS::RIFTEK_BIN_PROTOCOL;
  config_params_device.baud_rate = BAUR_RATE_UART::Baud9600;
  config_params_device.network_address = 1;
  config_params_device.number_serial_port = "COM4";

  std::shared_ptr<rf60x> dev = std::make_shared<rf60x>(config_params_device);

  std::cout << dev->open_port_uart() << std::endl;

  dev->change_config_port_uart();

  dev->send_command(COMMAND_UART::START_STREAM);

  uart_stream_measure_t measure;

  for (int i = 0; i < 1000; ++i) {
    if (dev->get_measure_uart(&measure,
                              PROTOCOL_MEASURE_UART::UART_STREAM_MEASURE_T)) {
      std::cout << "Measure : "
                << static_cast<double>(measure.value * 100.0 / 16384)
                << "  status : " << static_cast<uint32_t>(measure.status)
                << std::endl;
    }

    else {
      std::cout << "false" << std::endl;
    }
  }
  dev->send_command(COMMAND_UART::STOP_STREAM);

  dev->close_port_uart();
}
