﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using rf60Xsdk;

namespace RF60X_UART_Measure
{
    class Program
    {
        static void Main(string[] args)
        {
            Console.WriteLine(rf60XsdkNet.sdk_init());
            var config = new config_base_information_rf60x_net_t();
            config.type = SCANNER_TYPE_NET.RF60x;
            config.baud_rate = BAUR_RATE_UART_NET.Baud9600;
            config.network_address = 1;
            config.serial_port_number = "COM4";
            config.protocol = PROTOCOLS_NET.RIFTEK_BIN_PROTOCOL;


            rf60XsdkNet rf60Xsdk = new rf60XsdkNet(config);

            Console.WriteLine(rf60Xsdk.open_port_uart());

            rf60Xsdk.change_config_port_uart();

            uart_hello_rf60x_net_t uart_net = rf60Xsdk.hello_msg_uart();

            Console.WriteLine(uart_net.deviceSerial);

            uart_stream_measure_net_t measure = new uart_stream_measure_net_t();

            rf60Xsdk.send_command(COMMAND_UART_NET.START_STREAM);

            for (int i = 0; i < 10; ++i)
            {

                rf60Xsdk.get_measure_uart(ref measure, PROTOCOL_MEASURE_UART_NET.UART_STREAM_MEASURE_T);
                Console.WriteLine("measure: {0:#,###.##} : status : {1}", (float)(measure.value * 100) / 16384.0, measure.status);
            }

            rf60Xsdk.send_command(COMMAND_UART_NET.STOP_STREAM);

            rf60Xsdk.close_port_uart();

        }
    }
}
