﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using rf60Xsdk;

namespace RF60x_Modbus_RTU
{
    class Program
    {
        static void Main(string[] args)
        {
            Console.WriteLine(rf60XsdkNet.sdk_init());
            var config = new config_base_information_rf60x_net_t();
            ushort[] data = new ushort[32];

            config.type = SCANNER_TYPE_NET.RF60x;
            config.baud_rate = BAUR_RATE_UART_NET.Baud9600;
            config.network_address = 1;
            config.serial_port_number = "COM4";
            config.protocol = PROTOCOLS_NET.RIFTEK_BIN_PROTOCOL;


            rf60XsdkNet rf60Xsdk = new rf60XsdkNet(config);

            Console.WriteLine(rf60Xsdk.open_port_uart());

            rf60Xsdk.change_config_port_uart();

            Console.WriteLine(rf60Xsdk.read_params_uart());

            Console.WriteLine("The current value of the parameter :{0}",rf60Xsdk.get_param(PARAM_NAME_KEY_NET.PROTOCOLS_INTERFACE));

            Console.WriteLine(rf60Xsdk.set_param(2));

            rf60Xsdk.write_params_uart();


            modbus_rtu_command_net_t command = new modbus_rtu_command_net_t();
            command.address = 1;
            command.id = 1;
            command.count_or_value = 6;
            command.command = 0x04;

            rf60Xsdk.send_command_modbus(ref command);

            rf60Xsdk.receive_data_modbus(data);

            Console.WriteLine("Device type: {0} \n " +
                              "Firmware version:{1} \n " +
                              "SerialNumber : {2} \n" +
                              "Base distance : {3} \n" +
                              "Measurement range :{4}\n" +
                              "Measured value : {5}\n", data[0], data[1], data[2], data[3], data[4], data[5]);
            
            // Laser power

            command.address = 10;
            command.count_or_value = 1;  // 0 - off, 1 - on
            command.command = 0x06;
            rf60Xsdk.send_command_modbus(ref command);


          /*  //Changing the Protocol to standard (RIFTEK)

            command.address = 39;
            command.count_or_value = 0;  // 0 - off, 1 - on
            command.command = 0x06;
            rf60Xsdk.send_command_modbus(ref command);*/

            rf60Xsdk.close_port_uart();

        }
    }
}
