#include "rf60Xsdk.h"

#include "rf60XsdkWrapper.h"

#define CPPSDK SDK::SCANNERS::RF60X::rf60x

struct C_rf60x {
  void* obj;
};

int version() { return SDK::SCANNERS::RF60X::sdk_version(); }

bool init() { return SDK::SCANNERS::RF60X::sdk_init(); }

void cleanup() { SDK::SCANNERS::RF60X::sdk_cleanup(); }

bool connect(C_rf60x_t* rf60x) {
  CPPSDK* obj;

  if (rf60x == NULL) return false;

  obj = static_cast<CPPSDK*>(rf60x->obj);

  return obj->connect();
}

bool disconnect(C_rf60x_t* rf60x) {
  CPPSDK* obj;

  if (rf60x == NULL) return false;

  obj = static_cast<CPPSDK*>(rf60x->obj);

  return obj->disconnect();
}

bool get_measure_udp(C_rf60x_t* rf60x, void* measure) {
  CPPSDK* obj;

  if (rf60x == NULL) return false;

  obj = static_cast<CPPSDK*>(rf60x->obj);

  return obj->get_measure_udp(measure);
}

bool open_port_uart(C_rf60x_t* rf60x) {
  CPPSDK* obj;

  if (rf60x == NULL) return false;

  obj = static_cast<CPPSDK*>(rf60x->obj);

  return obj->open_port_uart();
}

rf60x_uart_hello_t hello_msg_uart(C_rf60x_t* rf60x) {
  CPPSDK* obj;
  rf60x_uart_hello_t innerHelloWord;

  obj = static_cast<CPPSDK*>(rf60x->obj);

  innerHelloWord.deviceMaxDistance = obj->hello_msg_uart().deviceMaxDistance;
  innerHelloWord.deviceModificaton = obj->hello_msg_uart().deviceModificaton;
  innerHelloWord.deviceRange = obj->hello_msg_uart().deviceRange;
  innerHelloWord.deviceSerial = obj->hello_msg_uart().deviceSerial;
  innerHelloWord.deviceType = obj->hello_msg_uart().deviceType;

  return innerHelloWord;
}

void change_config_port_uart(C_rf60x_t* rf60x) {
  CPPSDK* obj;

  if (rf60x == NULL) return;

  obj = static_cast<CPPSDK*>(rf60x->obj);

  obj->change_config_port_uart();
}

void close_port_uart(C_rf60x_t* rf60x) {
  CPPSDK* obj;

  if (rf60x == NULL) return;

  obj = static_cast<CPPSDK*>(rf60x->obj);

  obj->close_port_uart();
}

C_rf60x_t* create_rf60x(C_config_base_information_rf60x_t& config) {
  C_rf60x_t* m;

  CPPSDK* obj;

  m = (decltype(m))malloc(sizeof(*m));

  config_base_information_rf60x_t config_params_device;

  config_params_device.type = config.type;
  config_params_device.baud_rate = config.baud_rate;
  config_params_device.network_address = config.network_address;
  config_params_device.number_serial_port = config.number_serial_port;

  config_params_device.recv_ip_addrs = config.recv_ip_addrs;

  obj = new CPPSDK(config_params_device);
  m->obj = obj;

  return m;
}

void destroy_r60x(C_rf60x_t* rf60x) {
  if (rf60x == NULL) return;
  delete static_cast<CPPSDK*>(rf60x->obj);
  free(rf60x);
}
