#ifndef RF60X_H
#define RF60X_H

#include <rf60xtypes_c.h>
#ifdef __cplusplus
extern "C" {
#endif

//struct mather;
//typedef struct mather mather_t;

//mather_t *mather_create(int start);
//void mather_destroy(mather_t *m);

//void mather_add(mather_t *m, int val);
//int mather_val(mather_t *m);


struct rf60x_c;
typedef struct rf60x_c rf60x_t;

rf60x_t *rf60x_create(const namespace_struct_wrapper::config_base_information_rf60x_t config_params_device);
void rf60x_destroy(rf60x_t *m);

bool rf60x_connect(rf60x_t *dev);

bool rf60x_disconnect(rf60x_t *dev);

bool rf60x_get_measure_udp(rf60x_t *dev, void *measure);

bool rf60x_open_port_uart(rf60x_t *dev);

namespace_struct_wrapper::uart_hello_t rf60x_hello_msg_uart(rf60x_t *dev);

void rf60x_change_config_port_uart(rf60x_t *dev);

void rf60x_close_port_uart(rf60x_t *dev);

bool rf60x_get_measure_uart(rf60x_t *dev, void *measure, namespace_struct_wrapper::PROTOCOL_MEASURE_UART type);

bool rf60x_get_single_measure(rf60x_t *dev, unsigned char address, void *measure);

bool rf60x_send_command_modbus(rf60x_t *dev, const namespace_struct_wrapper::modbus_rtu_command &command);

bool rf60x_receive_data_modbus(rf60x_t *dev, unsigned short *buffer);

bool rf60x_read_params_uart(rf60x_t *dev);

bool rf60x_write_params_uart(rf60x_t *dev);

bool r60x_restore_params(rf60x_t *dev);

bool rf60x_send_command(rf60x_t *dev, namespace_struct_wrapper::COMMAND_UART CMD);

//param_t *rf60x_get_param(rf60x_t, char *param_name);
//param_t *rf60x_get_param(rf60x_t, PARAM_NAME_KEY param_name);

//bool rf60x_set_param(rf60x_t, param_t *param);
//bool rf60x_set_param(rf60x_t, const char *param_name, ...);
//bool rf60x_set_param(rf60x_t, int param_id, ...);

#ifdef __cplusplus
}
#endif

#endif // RF60X_H
