#ifndef RF60XTYPES_C_H
#define RF60XTYPES_C_H

typedef struct {
  typedef struct {
    unsigned short measure;
    unsigned short rotationMarks;
    unsigned short encoderValue;
  } uart_result_with_encoder_t;

  typedef struct {
    unsigned short value;
    unsigned char status;
  } udp_value_t;

  typedef struct {
    udp_value_t rf60xValArray[168];
    unsigned short deviceSerial;
    unsigned short deviceBaseDistance;
    unsigned short deviceMeasureRange;
    unsigned char packCount;
    unsigned char packetControlSumm;
  } udp_measure_t;

  typedef struct {
    unsigned short value;
    unsigned char count;
    unsigned char status;
    unsigned char reserverd;
  } uart_stream_measure_t;

  typedef struct {
    unsigned short value;
    unsigned char status;
    unsigned char dir;
    unsigned char cnt;
  } uart_stream_advanced_measure_t;

  typedef struct {
    unsigned short value;
    unsigned char status;
    unsigned char dir;
    unsigned char cnt;
    unsigned short cnt_stream;
  } uart_stream_modified_measure_t;

  typedef struct {
    unsigned short measure;
    unsigned short exposition;
    unsigned char status;
  } binocular_udp_value_t;

  typedef struct {
    binocular_udp_value_t rf60xBValArray[100];
    unsigned short reserved;
    unsigned short reserved2;
    unsigned short deviceSerial;
    unsigned short deviceBaseDistance;
    unsigned short deviceMeasureRange;
    unsigned char packCount;
    unsigned char packetControlSumm;
  } binocular_udp_measure_t;

  typedef struct {
    unsigned char deviceType;
    unsigned char deviceModificaton;
    unsigned short deviceSerial;
    unsigned short deviceMaxDistance;
    unsigned short deviceRange;

  } uart_hello_t;

  typedef struct {
    unsigned char id;
    unsigned char command;
    unsigned short address;
    unsigned short count_or_value;
    unsigned short crc;
  } modbus_rtu_command;

  enum SCANNER_TYPE { RF60x = 1, RF60xHS = 2, RF60xB = 3 };

  enum PROTOCOLS {
    RIFTEK_BIN_PROTOCOL = 1,
    ASCII = 2,
    MODBUS_RTU = 3,
  };

  /*const static char* parameter_names[] = {
      "user_power",
      "power_analog_output",
      "control_of_averaging",
      "network_address_uart",
      "baud_rate_uart",
      "number_of_averaged_values",
      "low_byte_of_the_sampling_period",
      "high_byte_of_the_sampling_period",
      "low_byte_of_max_integration_time",
      "high_byte_of_max_integration_time",
      "low_byte_for_the_beginning_of_analog_out_range",
      "high_byte_for_the_beginning_of_analog_out_range",
      "low_byte_for_the_end_of_analog_out_range",
      "high_byte_for_the_end_of_analog_out_range",
      "time_lock_of_result",
      "low_byte_of_a_zero_point",
      "high_byte_of_a_zero_point",
      "data_transfer_rate_via_CAN_interface",
      "low_byte_of_standard_identifier",
      "high_byte_of_standard_identifier",
      "zero_byte_of_extended_identifier",
      "first_byte_of_extended_identifie",
      "second_byte_of_extended_identifier",
      "third_byte_of_extended_identifier",
      "CAN_interface_identifier",
      "CAN_interface_power_switch",
      "zero_byte_of_destination_ip_address",
      "first_byte_of_destination_ip_address",
      "second_byte_of_destination_ip_address",
      "third_byte_of_destination_ip_address",
      "zero_byte_of_gateway_ip_address",
      "first_byte_of_gateway_ip_address",
      "second_byte_of_gateway_ip_address",
      "third_byte_of_gateway_ip_address",
      "zero_byte_of_subnet_mask",
      "first_byte_of_subnet_mask",
      "second_byte_of_subnet_mask",
      "third_byte_of_subnet_mask",
      "zero_byte_of_source_ip_address",
      "first_byte_of_source_ip_address",
      "second_byte_of_source_ip_address",
      "third_byte_of_source_ip_address",
      "low_byte_of_the_number_of_measurements_in_the_packet",
      "high_byte_of_the_number_of_measurements_in_the_packet",
      "eth_interface_on_off",
      "auto_of_the_stream",
      "protocols_interface",
  };*/
  enum PARAM_NAME_KEY {
    USER_POWER = 0,
    POWER_ANALOG_OUTPUT,
    CONTROL_OF_AVERAGING,
    NETWORK_ADDRESS_UART,
    BAUD_RATE_UART,
    NUMBER_OF_AVERAGED_VALUES,
    LOW_BYTE_OF_THE_SAMPLING_PERIOD,
    HIGH_BYTE_OF_THE_SAMPLING_PERIOD,
    LOW_BYTE_OF_MAX_INTEGRATION_TIME,
    HIGH_BYTE_OF_MAX_INTEGRATION_TIME,
    LOW_BYTE_FOR_THE_BEGINNING_OF_ANALOG_OUT_RANGE,
    HIGH_BYTE_FOR_THE_BEGINNING_OF_ANALOG_OUT_RANGE,
    LOW_BYTE_FOR_THE_END_OF_ANALOG_OUT_RANGE,
    HIGH_BYTE_FOR_THE_END_OF_ANALOG_OUT_RANGE,
    TIME_LOCK_OF_RESULT,
    LOW_BYTE_OF_A_ZERO_POINT,
    HIGH_BYTE_OF_A_ZERO_POINT,
    DATA_TRANSFER_RATE_VIA_CAN_INTERFACE,
    LOW_BYTE_OF_STANDARD_IDENTIFIER,
    HIGH_BYTE_OF_STANDARD_IDENTIFIER,
    ZERO_BYTE_OF_EXTENDED_IDENTIFIER,
    FIRST_BYTE_OF_EXTENDED_IDENTIFIE,
    SECOND_BYTE_OF_EXTENDED_IDENTIFIER,
    THIRD_BYTE_OF_EXTENDED_IDENTIFIER,
    CAN_INTERFACE_IDENTIFIER,
    CAN_INTERFACE_POWER_SWITCH,
    ZERO_BYTE_OF_DESTINATION_IP_ADDRESS,
    FIRST_BYTE_OF_DESTINATION_IP_ADDRESS,
    SECOND_BYTE_OF_DESTINATION_IP_ADDRESS,
    THIRD_BYTE_OF_DESTINATION_IP_ADDRESS,
    ZERO_BYTE_OF_GATEWAY_IP_ADDRESS,
    FIRST_BYTE_OF_GATEWAY_IP_ADDRESS,
    SECOND_BYTE_OF_GATEWAY_IP_ADDRESS,
    THIRD_BYTE_OF_GATEWAY_IP_ADDRESS,
    ZERO_BYTE_OF_SUBNET_MASK,
    FIRST_BYTE_OF_SUBNET_MASK,
    SECOND_BYTE_OF_SUBNET_MASK,
    THIRD_BYTE_OF_SUBNET_MASK,
    ZERO_BYTE_OF_SOURCE_IP_ADDRESS,
    FIRST_BYTE_OF_SOURCE_IP_ADDRESS,
    SECOND_BYTE_OF_SOURCE_IP_ADDRESS,
    THIRD_BYTE_OF_SOURCE_IP_ADDRESS,
    LOW_BYTE_OF_THE_NUMBER_OF_MEASUREMENTS_IN_THE_PACKET,
    HIGH_BYTE_OF_THE_NUMBER_OF_MEASUREMENTS_IN_THE_PACKET,
    ETH_INTERFACE_ON_OFF,
    AUTO_OF_THE_STREAM,
    PROTOCOLS_INTERFACE
  };

  enum PARAM_VALUE_TYPE {
    UNKN_PARAM_TYPE = 0,
    UINT8_PARAM_TYPE,
    UINT_PARAM_TYPE,
    UINT64_PARAM_TYPE,
    INT_PARAM_TYPE,
    INT64_PARAM_TYPE,
    FLOAT_PARAM_TYPE,
    DOUBLE_PARAM_TYPE,
    UINT32_ARRAY_PARAM_TYPE,
    UINT64_ARRAY_PARAM_TYPE,
    INT32_ARRAY_PARAM_TYPE,
    INT64_ARRAY_PARAM_TYPE,
    FLT_ARRAY_PARAM_TYPE,
    DBL_ARRAY_PARAM_TYPE,
    STRING_PARAM_TYPE
  };

  enum BAUR_RATE_UART {
    Baud9600 = 0x04,
    Baud115200 = 0x30,
    Baud230400 = 0x60,
    Baud460800 = 0xC0,
    Baud921600 = 0x180,

  };

  enum COMMAND_UART {
    WRITEPARAM = 0x03,
    SAVETOFLASH = 0x04,
    RESTOREFORMFLASH = 0x04,
    GETRESULT = 0x06,
    START_STREAM = 0x07,
    START_STREAM_ADVANCED = 0x0C,
    START_STREAM_MODIFIED = 0x0D,
    STOP_STREAM = 0x08
  };

  enum PROTOCOL_MEASURE_UART {
    UART_STREAM_MEASURE_T = 4,
    UART_STREAM_ADVANCED_MEASURE_T = 6,
    UART_STREAM_MODIFIED_MEASURE_T = 10,
    UART_RESULT_WITH_ENCODER_T = 12

  };

  typedef struct {
    SCANNER_TYPE type;
    BAUR_RATE_UART baud_rate;
    unsigned char network_address;
    char* number_serial_port;
    PROTOCOLS protocol;
    char* recv_ip_addrs;
  } config_base_information_rf60x_t;
}namespace_struct_wrapper;

#endif  // RF60XTYPES_C_H
